Index: palm/trunk/SOURCE/nesting_offl_mod.f90
===================================================================
--- palm/trunk/SOURCE/nesting_offl_mod.f90	(revision 4225)
+++ palm/trunk/SOURCE/nesting_offl_mod.f90	(revision 4226)
@@ -197,4 +339,464 @@
  CONTAINS
 
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Reads data at lateral and top boundaries derived from larger-scale model.
+!------------------------------------------------------------------------------!
+    SUBROUTINE nesting_offl_input
+
+       INTEGER(iwp) ::  n   !< running index for chemistry variables
+       INTEGER(iwp) ::  t   !< running index time dimension
+
+!
+!--    Initialize INIFOR forcing in first call. 
+       IF ( .NOT. nest_offl%init )  THEN
+#if defined ( __netcdf )
+!
+!--       Open file in read-only mode
+          CALL open_read_file( TRIM( input_file_dynamic ) //                   &
+                               TRIM( coupling_char ), pids_id )
+!
+!--       At first, inquire all variable names.
+          CALL inquire_num_variables( pids_id, num_var_pids )
+!
+!--       Allocate memory to store variable names.
+          ALLOCATE( nest_offl%var_names(1:num_var_pids) )
+          CALL inquire_variable_names( pids_id, nest_offl%var_names )
+!
+!--       Read time dimension, allocate memory and finally read time array
+          CALL get_dimension_length( pids_id, nest_offl%nt, 'time' )
+
+          IF ( check_existence( nest_offl%var_names, 'time' ) )  THEN
+             ALLOCATE( nest_offl%time(0:nest_offl%nt-1) )
+             CALL get_variable( pids_id, 'time', nest_offl%time )
+          ENDIF
+!
+!--       Read vertical dimension of scalar und w grid
+          CALL get_dimension_length( pids_id, nest_offl%nzu, 'z' )
+          CALL get_dimension_length( pids_id, nest_offl%nzw, 'zw' )
+
+          IF ( check_existence( nest_offl%var_names, 'z' ) )  THEN
+             ALLOCATE( nest_offl%zu_atmos(1:nest_offl%nzu) )
+             CALL get_variable( pids_id, 'z', nest_offl%zu_atmos )
+          ENDIF
+          IF ( check_existence( nest_offl%var_names, 'zw' ) )  THEN
+             ALLOCATE( nest_offl%zw_atmos(1:nest_offl%nzw) )
+             CALL get_variable( pids_id, 'zw', nest_offl%zw_atmos )
+          ENDIF
+!
+!--       Read surface pressure
+          IF ( check_existence( nest_offl%var_names,                           &
+                                'surface_forcing_surface_pressure' ) )  THEN
+             ALLOCATE( nest_offl%surface_pressure(0:nest_offl%nt-1) )
+             CALL get_variable( pids_id,                                       &
+                                'surface_forcing_surface_pressure',            &
+                                nest_offl%surface_pressure )
+          ENDIF
+!
+!--       Close input file
+          CALL close_input_file( pids_id )
+#endif
+       ENDIF
+!
+!--    Check if dynamic driver data input is required.
+       IF ( nest_offl%time(nest_offl%tind_p) <=                                &
+            MAX( time_since_reference_point, 0.0_wp) + time_utc_init  .OR.                   &
+            .NOT.  nest_offl%init )  THEN
+          CONTINUE
+!
+!--    Return otherwise
+       ELSE
+          RETURN
+       ENDIF
+!
+!--    CPU measurement
+       CALL cpu_log( log_point_s(86), 'NetCDF input forcing', 'start' )
+
+!
+!--    Obtain time index for current point in time. Note, the time coordinate
+!--    in the input file is relative to time_utc_init. Since time_since_...
+!--    is negativ when spinup is used, use MAX function to obtain correct 
+!--    time at the beginning. 
+       nest_offl%tind = MINLOC( ABS( nest_offl%time - (                        &
+                                     time_utc_init +                           &
+                                     MAX( time_since_reference_point, 0.0_wp) )&
+                                   ), DIM = 1 ) - 1
+       nest_offl%tind_p = nest_offl%tind + 1
+!
+!--    Open file in read-only mode
+#if defined ( __netcdf )
+       CALL open_read_file( TRIM( input_file_dynamic ) //                      &
+                            TRIM( coupling_char ), pids_id )
+!
+!--    Read geostrophic wind components
+       DO  t = nest_offl%tind, nest_offl%tind_p
+          CALL get_variable_pr( pids_id, 'ls_forcing_ug', t+1,                 &
+                                nest_offl%ug(t-nest_offl%tind,nzb+1:nzt) )
+          CALL get_variable_pr( pids_id, 'ls_forcing_vg', t+1,                 &
+                                nest_offl%vg(t-nest_offl%tind,nzb+1:nzt) )
+       ENDDO
+!
+!--    Read data at lateral and top boundaries. Please note, at left and
+!--    right domain boundary, yz-layers are read for u, v, w, pt and q.
+!--    For the v-component, the data starts at nysv, while for the other
+!--    quantities the data starts at nys. This is equivalent at the north
+!--    and south domain boundary for the u-component. 
+!--    Note, lateral data is also accessed by parallel IO, which is the reason
+!--    why different arguments are passed depending on the boundary control
+!--    flags. Cores that do not belong to the respective boundary just make
+!--    a dummy read with count = 0, just in order to participate the collective
+!--    operation. 
+!--    Read data for western boundary    
+       CALL get_variable( pids_id, 'ls_forcing_left_u',                        &
+                          nest_offl%u_left,                                    & ! array to be read
+                          MERGE( nys+1, 1, bc_dirichlet_l),                    & ! start index y direction
+                          MERGE( nzb+1, 1, bc_dirichlet_l),                    & ! start index z direction
+                          MERGE( nest_offl%tind+1, 1, bc_dirichlet_l),         & ! start index time dimension
+                          MERGE( nyn-nys+1, 0, bc_dirichlet_l),                & ! number of elements along y
+                          MERGE( nest_offl%nzu, 0, bc_dirichlet_l),            & ! number of elements alogn z
+                          MERGE( 2, 0, bc_dirichlet_l),                        & ! number of time steps (2 or 0)
+                          .TRUE. )                                               ! parallel IO when compiled accordingly
+      
+       CALL get_variable( pids_id, 'ls_forcing_left_v',                        &
+                          nest_offl%v_left,                                    &
+                          MERGE( nysv, 1, bc_dirichlet_l),                     &
+                          MERGE( nzb+1, 1, bc_dirichlet_l),                    &
+                          MERGE( nest_offl%tind+1, 1, bc_dirichlet_l),         &
+                          MERGE( nyn-nysv+1, 0, bc_dirichlet_l),               &
+                          MERGE( nest_offl%nzu, 0, bc_dirichlet_l),            &
+                          MERGE( 2, 0, bc_dirichlet_l),                        &
+                          .TRUE. )                                        
+
+       CALL get_variable( pids_id, 'ls_forcing_left_w',                        &
+                          nest_offl%w_left,                                    &
+                          MERGE( nys+1, 1, bc_dirichlet_l),                    &
+                          MERGE( nzb+1, 1, bc_dirichlet_l),                    &
+                          MERGE( nest_offl%tind+1, 1, bc_dirichlet_l),         &
+                          MERGE( nyn-nys+1, 0, bc_dirichlet_l),                &
+                          MERGE( nest_offl%nzw, 0, bc_dirichlet_l),            &
+                          MERGE( 2, 0, bc_dirichlet_l),                        &
+                          .TRUE. )   
+
+       IF ( .NOT. neutral )  THEN
+          CALL get_variable( pids_id, 'ls_forcing_left_pt',                    &
+                             nest_offl%pt_left,                                &
+                             MERGE( nys+1, 1, bc_dirichlet_l),                 &
+                             MERGE( nzb+1, 1, bc_dirichlet_l),                 &
+                             MERGE( nest_offl%tind+1, 1, bc_dirichlet_l),      &
+                             MERGE( nyn-nys+1, 0, bc_dirichlet_l),             &
+                             MERGE( nest_offl%nzu, 0, bc_dirichlet_l),         &
+                             MERGE( 2, 0, bc_dirichlet_l),                     &
+                             .TRUE. )
+       ENDIF
+
+       IF ( humidity )  THEN
+          CALL get_variable( pids_id, 'ls_forcing_left_qv',                    &
+                             nest_offl%q_left,                                 &
+                             MERGE( nys+1, 1, bc_dirichlet_l),                 &
+                             MERGE( nzb+1, 1, bc_dirichlet_l),                 &
+                             MERGE( nest_offl%tind+1, 1, bc_dirichlet_l),      &
+                             MERGE( nyn-nys+1, 0, bc_dirichlet_l),             &
+                             MERGE( nest_offl%nzu, 0, bc_dirichlet_l),         &
+                             MERGE( 2, 0, bc_dirichlet_l),                     &
+                             .TRUE. )
+       ENDIF
+       
+       IF ( air_chemistry )  THEN
+          DO  n = 1, UBOUND(nest_offl%var_names_chem_l, 1)
+             IF ( check_existence( nest_offl%var_names,                        &
+                                   nest_offl%var_names_chem_l(n) ) )  THEN  
+                CALL get_variable( pids_id,                                    &
+                           TRIM( nest_offl%var_names_chem_l(n) ),              &
+                           nest_offl%chem_left(:,:,:,n),                       &
+                           MERGE( nys+1, 1, bc_dirichlet_l),                   &
+                           MERGE( nzb+1, 1, bc_dirichlet_l),                   &
+                           MERGE( nest_offl%tind+1, 1, bc_dirichlet_l),        &
+                           MERGE( nyn-nys+1, 0, bc_dirichlet_l),               &
+                           MERGE( nest_offl%nzu, 0, bc_dirichlet_l),           &
+                           MERGE( 2, 0, bc_dirichlet_l),                       &
+                           .TRUE. )
+                nest_offl%chem_from_file_l(n) = .TRUE.
+             ENDIF
+          ENDDO
+       ENDIF
+!
+!--    Read data for eastern boundary    
+       CALL get_variable( pids_id, 'ls_forcing_right_u',                       &
+                          nest_offl%u_right,                                   &
+                          MERGE( nys+1, 1, bc_dirichlet_r),                    &
+                          MERGE( nzb+1, 1, bc_dirichlet_r),                    &
+                          MERGE( nest_offl%tind+1, 1, bc_dirichlet_r),         &
+                          MERGE( nyn-nys+1, 0, bc_dirichlet_r),                &
+                          MERGE( nest_offl%nzu, 0, bc_dirichlet_r),            &
+                          MERGE( 2, 0, bc_dirichlet_r),                        &
+                          .TRUE. )                                             
+      
+       CALL get_variable( pids_id, 'ls_forcing_right_v',                       &
+                          nest_offl%v_right,                                   &
+                          MERGE( nysv, 1, bc_dirichlet_r),                     &
+                          MERGE( nzb+1, 1, bc_dirichlet_r),                    &
+                          MERGE( nest_offl%tind+1, 1, bc_dirichlet_r),         &
+                          MERGE( nyn-nysv+1, 0, bc_dirichlet_r),               &
+                          MERGE( nest_offl%nzu, 0, bc_dirichlet_r),            &
+                          MERGE( 2, 0, bc_dirichlet_r),                        &
+                          .TRUE. )                                             
+
+       CALL get_variable( pids_id, 'ls_forcing_right_w',                       &
+                          nest_offl%w_right,                                   &
+                          MERGE( nys+1, 1, bc_dirichlet_r),                    &
+                          MERGE( nzb+1, 1, bc_dirichlet_r),                    &
+                          MERGE( nest_offl%tind+1, 1, bc_dirichlet_r),         &
+                          MERGE( nyn-nys+1, 0, bc_dirichlet_r),                &
+                          MERGE( nest_offl%nzw, 0, bc_dirichlet_r),            &
+                          MERGE( 2, 0, bc_dirichlet_r),                        &
+                          .TRUE. )   
+
+       IF ( .NOT. neutral )  THEN
+          CALL get_variable( pids_id, 'ls_forcing_right_pt',                   &
+                             nest_offl%pt_right,                               &
+                             MERGE( nys+1, 1, bc_dirichlet_r),                 &
+                             MERGE( nzb+1, 1, bc_dirichlet_r),                 &
+                             MERGE( nest_offl%tind+1, 1, bc_dirichlet_r),      &
+                             MERGE( nyn-nys+1, 0, bc_dirichlet_r),             &
+                             MERGE( nest_offl%nzu, 0, bc_dirichlet_r),         &
+                             MERGE( 2, 0, bc_dirichlet_r),                     &
+                             .TRUE. )
+       ENDIF
+
+       IF ( humidity )  THEN
+          CALL get_variable( pids_id, 'ls_forcing_right_qv',                   &
+                             nest_offl%q_right,                                &
+                             MERGE( nys+1, 1, bc_dirichlet_r),                 &
+                             MERGE( nzb+1, 1, bc_dirichlet_r),                 &
+                             MERGE( nest_offl%tind+1, 1, bc_dirichlet_r),      &
+                             MERGE( nyn-nys+1, 0, bc_dirichlet_r),             &
+                             MERGE( nest_offl%nzu, 0, bc_dirichlet_r),         &
+                             MERGE( 2, 0, bc_dirichlet_r),                     &
+                             .TRUE. )
+       ENDIF
+       
+       IF ( air_chemistry )  THEN
+          DO  n = 1, UBOUND(nest_offl%var_names_chem_r, 1)
+             IF ( check_existence( nest_offl%var_names,                        &
+                                   nest_offl%var_names_chem_r(n) ) )  THEN     
+                CALL get_variable( pids_id,                                    &
+                           TRIM( nest_offl%var_names_chem_r(n) ),              &
+                           nest_offl%chem_right(:,:,:,n),                      &
+                           MERGE( nys+1, 1, bc_dirichlet_r),                   &
+                           MERGE( nzb+1, 1, bc_dirichlet_r),                   &
+                           MERGE( nest_offl%tind+1, 1, bc_dirichlet_r),        &
+                           MERGE( nyn-nys+1, 0, bc_dirichlet_r),               &
+                           MERGE( nest_offl%nzu, 0, bc_dirichlet_r),           &
+                           MERGE( 2, 0, bc_dirichlet_r),                       &
+                           .TRUE. )
+                nest_offl%chem_from_file_r(n) = .TRUE.
+             ENDIF
+          ENDDO
+       ENDIF
+!
+!--    Read data for northern boundary
+       CALL get_variable( pids_id, 'ls_forcing_north_u',                       & ! array to be read
+                          nest_offl%u_north,                                   & ! start index x direction
+                          MERGE( nxlu, 1, bc_dirichlet_n ),                    & ! start index z direction
+                          MERGE( nzb+1, 1, bc_dirichlet_n ),                   & ! start index time dimension
+                          MERGE( nest_offl%tind+1, 1, bc_dirichlet_n ),        & ! number of elements along x
+                          MERGE( nxr-nxlu+1, 0, bc_dirichlet_n ),              & ! number of elements alogn z 
+                          MERGE( nest_offl%nzu, 0, bc_dirichlet_n ),           & ! number of time steps (2 or 0)
+                          MERGE( 2, 0, bc_dirichlet_n ),                       & ! parallel IO when compiled accordingly
+                          .TRUE. )                                             
+                                                                               
+       CALL get_variable( pids_id, 'ls_forcing_north_v',                       & ! array to be read
+                          nest_offl%v_north,                                   & ! start index x direction
+                          MERGE( nxl+1, 1, bc_dirichlet_n ),                   & ! start index z direction
+                          MERGE( nzb+1, 1, bc_dirichlet_n ),                   & ! start index time dimension
+                          MERGE( nest_offl%tind+1, 1, bc_dirichlet_n ),        & ! number of elements along x
+                          MERGE( nxr-nxl+1, 0, bc_dirichlet_n ),               & ! number of elements alogn z 
+                          MERGE( nest_offl%nzu, 0, bc_dirichlet_n ),           & ! number of time steps (2 or 0)
+                          MERGE( 2, 0, bc_dirichlet_n ),                       & ! parallel IO when compiled accordingly
+                          .TRUE. )                                             
+                                                                               
+       CALL get_variable( pids_id, 'ls_forcing_north_w',                       & ! array to be read
+                          nest_offl%w_north,                                   & ! start index x direction
+                          MERGE( nxl+1, 1, bc_dirichlet_n ),                   & ! start index z direction
+                          MERGE( nzb+1, 1, bc_dirichlet_n ),                   & ! start index time dimension
+                          MERGE( nest_offl%tind+1, 1, bc_dirichlet_n ),        & ! number of elements along x
+                          MERGE( nxr-nxl+1, 0, bc_dirichlet_n ),               & ! number of elements alogn z 
+                          MERGE( nest_offl%nzw, 0, bc_dirichlet_n ),           & ! number of time steps (2 or 0)
+                          MERGE( 2, 0, bc_dirichlet_n ),                       & ! parallel IO when compiled accordingly
+                          .TRUE. )                                             
+                                                                               
+       IF ( .NOT. neutral )  THEN                                              
+          CALL get_variable( pids_id, 'ls_forcing_north_pt',                   & ! array to be read
+                             nest_offl%pt_north,                               & ! start index x direction
+                             MERGE( nxl+1, 1, bc_dirichlet_n ),                & ! start index z direction
+                             MERGE( nzb+1, 1, bc_dirichlet_n ),                & ! start index time dimension
+                             MERGE( nest_offl%tind+1, 1, bc_dirichlet_n ),     & ! number of elements along x
+                             MERGE( nxr-nxl+1, 0, bc_dirichlet_n ),            & ! number of elements alogn z 
+                             MERGE( nest_offl%nzu, 0, bc_dirichlet_n ),        & ! number of time steps (2 or 0)
+                             MERGE( 2, 0, bc_dirichlet_n ),                    & ! parallel IO when compiled accordingly
+                             .TRUE. )                                             
+       ENDIF                                                                   
+       IF ( humidity )  THEN                                                   
+          CALL get_variable( pids_id, 'ls_forcing_north_qv',                   & ! array to be read
+                             nest_offl%q_north,                                & ! start index x direction
+                             MERGE( nxl+1, 1, bc_dirichlet_n ),                & ! start index z direction
+                             MERGE( nzb+1, 1, bc_dirichlet_n ),                & ! start index time dimension
+                             MERGE( nest_offl%tind+1, 1, bc_dirichlet_n ),     & ! number of elements along x
+                             MERGE( nxr-nxl+1, 0, bc_dirichlet_n ),            & ! number of elements alogn z 
+                             MERGE( nest_offl%nzu, 0, bc_dirichlet_n ),        & ! number of time steps (2 or 0)
+                             MERGE( 2, 0, bc_dirichlet_n ),                    & ! parallel IO when compiled accordingly
+                             .TRUE. )                                             
+       ENDIF                                                                   
+                                                                               
+       IF ( air_chemistry )  THEN                                              
+          DO  n = 1, UBOUND(nest_offl%var_names_chem_n, 1)                     
+             IF ( check_existence( nest_offl%var_names,                        &
+                                   nest_offl%var_names_chem_n(n) ) )  THEN     
+                CALL get_variable( pids_id,                                    &
+                           TRIM( nest_offl%var_names_chem_n(n) ),              &
+                           nest_offl%chem_north(:,:,:,n),                      &
+                           MERGE( nxl+1, 1, bc_dirichlet_n ),                  &
+                           MERGE( nzb+1, 1, bc_dirichlet_n ),                  &
+                           MERGE( nest_offl%tind+1, 1, bc_dirichlet_n ),       &
+                           MERGE( nxr-nxl+1, 0, bc_dirichlet_n ),              &
+                           MERGE( nest_offl%nzu, 0, bc_dirichlet_n ),          &
+                           MERGE( 2, 0, bc_dirichlet_n ),                      &
+                           .TRUE. )
+                nest_offl%chem_from_file_n(n) = .TRUE.
+             ENDIF
+          ENDDO
+       ENDIF
+!
+!--    Read data for southern boundary
+       CALL get_variable( pids_id, 'ls_forcing_south_u',                       & ! array to be read
+                          nest_offl%u_south,                                   & ! start index x direction
+                          MERGE( nxlu, 1, bc_dirichlet_s ),                    & ! start index z direction
+                          MERGE( nzb+1, 1, bc_dirichlet_s ),                   & ! start index time dimension
+                          MERGE( nest_offl%tind+1, 1, bc_dirichlet_s ),        & ! number of elements along x
+                          MERGE( nxr-nxlu+1, 0, bc_dirichlet_s ),              & ! number of elements alogn z 
+                          MERGE( nest_offl%nzu, 0, bc_dirichlet_s ),           & ! number of time steps (2 or 0)
+                          MERGE( 2, 0, bc_dirichlet_s ),                       & ! parallel IO when compiled accordingly
+                          .TRUE. )                                             
+                                                                               
+       CALL get_variable( pids_id, 'ls_forcing_south_v',                       & ! array to be read
+                          nest_offl%v_south,                                   & ! start index x direction
+                          MERGE( nxl+1, 1, bc_dirichlet_s ),                   & ! start index z direction
+                          MERGE( nzb+1, 1, bc_dirichlet_s ),                   & ! start index time dimension
+                          MERGE( nest_offl%tind+1, 1, bc_dirichlet_s ),        & ! number of elements along x
+                          MERGE( nxr-nxl+1, 0, bc_dirichlet_s ),               & ! number of elements alogn z 
+                          MERGE( nest_offl%nzu, 0, bc_dirichlet_s ),           & ! number of time steps (2 or 0)
+                          MERGE( 2, 0, bc_dirichlet_s ),                       & ! parallel IO when compiled accordingly
+                          .TRUE. )                                             
+                                                                               
+       CALL get_variable( pids_id, 'ls_forcing_south_w',                       & ! array to be read
+                          nest_offl%w_south,                                   & ! start index x direction
+                          MERGE( nxl+1, 1, bc_dirichlet_s ),                   & ! start index z direction
+                          MERGE( nzb+1, 1, bc_dirichlet_s ),                   & ! start index time dimension
+                          MERGE( nest_offl%tind+1, 1, bc_dirichlet_s ),        & ! number of elements along x
+                          MERGE( nxr-nxl+1, 0, bc_dirichlet_s ),               & ! number of elements alogn z 
+                          MERGE( nest_offl%nzw, 0, bc_dirichlet_s ),           & ! number of time steps (2 or 0)
+                          MERGE( 2, 0, bc_dirichlet_s ),                       & ! parallel IO when compiled accordingly
+                          .TRUE. )                                             
+                                                                               
+       IF ( .NOT. neutral )  THEN                                              
+          CALL get_variable( pids_id, 'ls_forcing_south_pt',                   & ! array to be read
+                             nest_offl%pt_south,                               & ! start index x direction
+                             MERGE( nxl+1, 1, bc_dirichlet_s ),                & ! start index z direction
+                             MERGE( nzb+1, 1, bc_dirichlet_s ),                & ! start index time dimension
+                             MERGE( nest_offl%tind+1, 1, bc_dirichlet_s ),     & ! number of elements along x
+                             MERGE( nxr-nxl+1, 0, bc_dirichlet_s ),            & ! number of elements alogn z 
+                             MERGE( nest_offl%nzu, 0, bc_dirichlet_s ),        & ! number of time steps (2 or 0)
+                             MERGE( 2, 0, bc_dirichlet_s ),                    & ! parallel IO when compiled accordingly
+                             .TRUE. )                                             
+       ENDIF                                                                   
+       IF ( humidity )  THEN                                                   
+          CALL get_variable( pids_id, 'ls_forcing_south_qv',                   & ! array to be read
+                             nest_offl%q_south,                                & ! start index x direction
+                             MERGE( nxl+1, 1, bc_dirichlet_s ),                & ! start index z direction
+                             MERGE( nzb+1, 1, bc_dirichlet_s ),                & ! start index time dimension
+                             MERGE( nest_offl%tind+1, 1, bc_dirichlet_s ),     & ! number of elements along x
+                             MERGE( nxr-nxl+1, 0, bc_dirichlet_s ),            & ! number of elements alogn z 
+                             MERGE( nest_offl%nzu, 0, bc_dirichlet_s ),        & ! number of time steps (2 or 0)
+                             MERGE( 2, 0, bc_dirichlet_s ),                    & ! parallel IO when compiled accordingly
+                             .TRUE. )                                             
+       ENDIF                                                                   
+                                                                               
+       IF ( air_chemistry )  THEN                                              
+          DO  n = 1, UBOUND(nest_offl%var_names_chem_s, 1)                     
+             IF ( check_existence( nest_offl%var_names,                        &
+                                   nest_offl%var_names_chem_s(n) ) )  THEN     
+                CALL get_variable( pids_id,                                    &
+                           TRIM( nest_offl%var_names_chem_s(n) ),              &
+                           nest_offl%chem_south(:,:,:,n),                      &
+                           MERGE( nxl+1, 1, bc_dirichlet_s ),                  &
+                           MERGE( nzb+1, 1, bc_dirichlet_s ),                  &
+                           MERGE( nest_offl%tind+1, 1, bc_dirichlet_s ),       &
+                           MERGE( nxr-nxl+1, 0, bc_dirichlet_s ),              &
+                           MERGE( nest_offl%nzu, 0, bc_dirichlet_s ),          &
+                           MERGE( 2, 0, bc_dirichlet_s ),                      &
+                           .TRUE. )
+                nest_offl%chem_from_file_s(n) = .TRUE.
+             ENDIF
+          ENDDO
+       ENDIF
+!
+!--    Top boundary
+       CALL get_variable( pids_id, 'ls_forcing_top_u',                         &
+                             nest_offl%u_top(0:1,nys:nyn,nxlu:nxr),            &
+                             nxlu, nys+1, nest_offl%tind+1,                    &
+                             nxr-nxlu+1, nyn-nys+1, 2, .TRUE. )
+
+       CALL get_variable( pids_id, 'ls_forcing_top_v',                         &
+                             nest_offl%v_top(0:1,nysv:nyn,nxl:nxr),            &
+                             nxl+1, nysv, nest_offl%tind+1,                    &
+                             nxr-nxl+1, nyn-nysv+1, 2, .TRUE. )
+                             
+       CALL get_variable( pids_id, 'ls_forcing_top_w',                         &
+                             nest_offl%w_top(0:1,nys:nyn,nxl:nxr),             &
+                             nxl+1, nys+1, nest_offl%tind+1,                   &
+                             nxr-nxl+1, nyn-nys+1, 2, .TRUE. )
+                             
+       IF ( .NOT. neutral )  THEN
+          CALL get_variable( pids_id, 'ls_forcing_top_pt',                     &
+                                nest_offl%pt_top(0:1,nys:nyn,nxl:nxr),         &
+                                nxl+1, nys+1, nest_offl%tind+1,                &
+                                nxr-nxl+1, nyn-nys+1, 2, .TRUE. )
+       ENDIF
+       IF ( humidity )  THEN
+          CALL get_variable( pids_id, 'ls_forcing_top_qv',                     &
+                                nest_offl%q_top(0:1,nys:nyn,nxl:nxr),          &
+                                nxl+1, nys+1, nest_offl%tind+1,                &
+                                nxr-nxl+1, nyn-nys+1, 2, .TRUE. )
+       ENDIF
+       
+       IF ( air_chemistry )  THEN
+          DO  n = 1, UBOUND(nest_offl%var_names_chem_t, 1)
+             IF ( check_existence( nest_offl%var_names,                        &
+                                   nest_offl%var_names_chem_t(n) ) )  THEN      
+                CALL get_variable( pids_id,                                    &
+                              TRIM( nest_offl%var_names_chem_t(n) ),           &
+                              nest_offl%chem_top(0:1,nys:nyn,nxl:nxr,n),       &
+                              nxl+1, nys+1, nest_offl%tind+1,                  &
+                              nxr-nxl+1, nyn-nys+1, 2, .TRUE. )
+                nest_offl%chem_from_file_t(n) = .TRUE.
+             ENDIF
+          ENDDO
+       ENDIF
+
+!
+!--    Close input file
+       CALL close_input_file( pids_id )
+#endif
+!
+!--    Set control flag to indicate that boundary data has been initially
+!--    input.
+       nest_offl%init = .TRUE.
+!
+!--    End of CPU measurement
+       CALL cpu_log( log_point_s(86), 'NetCDF input forcing', 'stop' )
+
+    END SUBROUTINE nesting_offl_input
+
 
 !------------------------------------------------------------------------------!
@@ -210,6 +812,4 @@
     SUBROUTINE nesting_offl_mass_conservation
 
-       IMPLICIT NONE
-
        INTEGER(iwp) ::  i !< grid index in x-direction
        INTEGER(iwp) ::  j !< grid index in y-direction
